<template>
  <section class="relative py-16 bg-secondary-100">
    <div class="container mx-auto">
      <div class="grid grid-cols-12 gap-0">
        <div class="col-span-12 px-10 bg-secondary-100">
          <div class="md:grid md:grid-cols-4 md:gap-5">
            <div class="md:col-span-1">
              <div class="px-4 sm:px-0">
                <h3 class="text-lg font-medium leading-6 text-gray-900">
                  Billing address
                </h3>
                <!-- <p class="mt-1 text-sm text-gray-600">
                  Lorem ipsum, dolor sit amet consectetur adipisicing elit.
                </p> -->
              </div>
            </div>
            <div class="mt-5 md:mt-0 md:col-span-3">
              <div class="shadow sm:rounded-md sm:overflow-hidden">
                <div class="px-4 py-5 space-y-6 bg-white sm:p-6">
                  <div class="grid grid-cols-4 gap-5">
                    <div class="col-span-4 sm:col-span-2">
                      <label
                        for="billingFirstname"
                        class="block text-sm font-medium text-black"
                      >
                        Firstname
                      </label>
                      <div class="mt-1">
                        <input
                          id="billingFirstname"
                          v-model="billing.firstName"
                          name="billingFirstname"
                          type="text"
                          required
                          class="w-full form-input"
                        />
                      </div>
                    </div>

                    <div class="col-span-4 sm:col-span-2">
                      <label
                        for="billingLastname"
                        class="block text-sm font-medium text-black"
                      >
                        Lastname
                      </label>
                      <div class="mt-1">
                        <input
                          id="billingLastname"
                          v-model="billing.lastName"
                          name="billingLastname"
                          type="text"
                          required
                          class="w-full form-input"
                        />
                      </div>
                    </div>

                    <div class="col-span-4 sm:col-span-2">
                      <label
                        for="billingEmail"
                        class="block text-sm font-medium text-black"
                      >
                        Email
                      </label>
                      <div class="mt-1">
                        <input
                          id="billingEmail"
                          v-model="billing.email"
                          name="billingEmail"
                          type="email"
                          required
                          class="w-full form-input"
                        />
                      </div>
                    </div>

                    <div class="col-span-4 sm:col-span-2">
                      <label
                        for="billingPhone"
                        class="block text-sm font-medium text-black"
                      >
                        Phone
                      </label>
                      <div class="mt-1">
                        <input
                          id="billingPhone"
                          v-model="billing.phone"
                          name="billingPhone"
                          type="tel"
                          required
                          class="w-full form-input"
                        />
                      </div>
                    </div>

                    <div class="col-span-4 sm:col-span-4">
                      <label
                        for="billingAddress1"
                        class="block text-sm font-medium text-black"
                      >
                        Address
                      </label>
                      <div class="mt-1">
                        <input
                          id="billingAddress1"
                          v-model="billing.address1"
                          name="billingAddress1"
                          type="text"
                          required
                          class="w-full form-input"
                        />
                      </div>
                    </div>

                    <div class="col-span-4 sm:col-span-3">
                      <label
                        for="billingAddress2"
                        class="block text-sm font-medium text-black"
                      >
                        Address 2
                        <span class="ml-2 text-xs text-secondary-200">
                          (optional)
                        </span>
                      </label>
                      <div class="mt-1">
                        <input
                          id="billingAddress2"
                          v-model="billing.address2"
                          data-validation="optional"
                          name="billingAddress2"
                          type="text"
                          required
                          class="w-full form-input"
                        />
                      </div>
                    </div>

                    <div class="col-span-4 sm:col-span-1">
                      <label
                        for="billingPostcode"
                        class="block text-sm font-medium text-black"
                      >
                        Postal code
                      </label>
                      <div class="mt-1">
                        <input
                          id="billingPostcode"
                          v-model="billing.postcode"
                          name="billingPostcode"
                          type="text"
                          required
                          class="w-full form-input"
                        />
                      </div>
                    </div>

                    <div class="col-span-4 sm:col-span-2 md:col-span-1">
                      <label
                        for="billingCity"
                        class="block text-sm font-medium text-black"
                      >
                        City
                      </label>
                      <div class="mt-1">
                        <input
                          id="billingCity"
                          v-model="billing.city"
                          name="billingCity"
                          type="text"
                          required
                          class="w-full form-input"
                        />
                      </div>
                    </div>

                    <div class="col-span-4 sm:col-span-2 md:col-span-1">
                      <label
                        for="billingState"
                        class="block text-sm font-medium text-black"
                      >
                        State
                      </label>
                      <div class="mt-1">
                        <input
                          id="billingState"
                          v-model="billing.state"
                          name="billingState"
                          type="text"
                          required
                          class="w-full form-input"
                        />
                      </div>
                    </div>

                    <div class="col-span-4 md:col-span-2">
                      <label
                        for="billingCountry"
                        class="block text-sm font-medium text-black"
                      >
                        Country
                      </label>
                      <div class="mt-1">
                        <select
                          id="billingCountry"
                          v-model="billing.country"
                          name="billingCountry"
                          type="text"
                          required
                          class="w-full form-select"
                        >
                          <option
                            v-for="(country, index) in countries"
                            :key="index"
                            :value="country.code"
                          >
                            {{ country.name }}
                          </option>
                        </select>
                      </div>
                    </div>

                    <!-- <div class="col-span-4 sm:col-span-4">
                      <div class="flex items-center">
                        <input
                          id="sameForShipping"
                          v-model="sameForShipping"
                          name="sameForShipping"
                          type="checkbox"
                          class="text-primary-400 form-checkbox"
                        />
                        <label
                          for="sameForShipping"
                          class="block ml-2 text-sm font-medium text-black"
                        >
                          Use same infomation for Shipping
                        </label>
                      </div>
                    </div> -->
                  </div>
                </div>
                <div class="px-4 py-3 text-right bg-gray-50 sm:px-6">
                  <button
                    type="submit"
                    class="inline-flex justify-center px-4 py-2 text-sm font-medium text-white border border-transparent rounded-md shadow-sm bg-primary-300 hover:bg-primary-400 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-primary-300"
                    @click.prevent="updateCustomer"
                  >
                    Save
                  </button>
                </div>
              </div>
            </div>
          </div>

          <div class="mt-5 md:grid md:grid-cols-4 md:gap-5">
            <div class="md:col-span-1">
              <div class="px-4 sm:px-0">
                <h3 class="text-lg font-medium leading-6 text-gray-900">
                  Shipping address
                </h3>
                <!-- <p class="mt-1 text-sm text-gray-600">
                  Lorem ipsum, dolor sit amet consectetur adipisicing elit.
                </p> -->
              </div>
            </div>

            <div class="mt-5 md:mt-0 md:col-span-3">
              <div class="shadow sm:rounded-md sm:overflow-hidden">
                <div class="px-4 py-5 space-y-6 bg-white sm:p-6">
                  <div class="grid grid-cols-4 gap-5">
                    <div class="col-span-4 sm:col-span-2">
                      <label
                        for="shippingFirstname"
                        class="block text-sm font-medium text-black"
                      >
                        Firstname
                      </label>
                      <div class="mt-1">
                        <input
                          id="shippingFirstname"
                          v-model="shipping.firstName"
                          name="shippingFirstname"
                          type="text"
                          required
                          class="w-full form-input"
                        />
                      </div>
                    </div>

                    <div class="col-span-4 sm:col-span-2">
                      <label
                        for="shippingLastname"
                        class="block text-sm font-medium text-black"
                      >
                        Lastname
                      </label>
                      <div class="mt-1">
                        <input
                          id="shippingLastname"
                          v-model="shipping.lastName"
                          name="shippingLastname"
                          type="text"
                          required
                          class="w-full form-input"
                        />
                      </div>
                    </div>

                    <!-- <div class="col-span-2">
                      <label
                        for="shippingEmail"
                        class="block text-sm font-medium text-black"
                      >
                        Email
                      </label>
                      <div class="mt-1">
                        <input
                          id="shippingEmail"
                          v-model="shipping.email"
                          name="shippingEmail"
                          type="email"
                          required
                          class="w-full form-input"
                        />
                      </div>
                    </div> -->

                    <!-- <div class="col-span-2">
                      <label
                        for="shippingPhone"
                        class="block text-sm font-medium text-black"
                      >
                        Phone
                      </label>
                      <div class="mt-1">
                        <input
                          id="shippingPhone"
                          v-model="shipping.phone"
                          name="shippingPhone"
                          type="tel"
                          required
                          class="w-full form-input"
                        />
                      </div>
                    </div> -->

                    <div class="col-span-4 sm:col-span-4">
                      <label
                        for="shippingAddress1"
                        class="block text-sm font-medium text-black"
                      >
                        Address
                      </label>
                      <div class="mt-1">
                        <input
                          id="shippingAddress1"
                          v-model="shipping.address1"
                          name="shippingAddress1"
                          type="text"
                          required
                          class="w-full form-input"
                        />
                      </div>
                    </div>

                    <div class="col-span-4 sm:col-span-3">
                      <label
                        for="shippingAddress2"
                        class="block text-sm font-medium text-black"
                      >
                        Address 2
                        <span class="ml-2 text-xs text-secondary-200">
                          (optional)
                        </span>
                      </label>
                      <div class="mt-1">
                        <input
                          id="shippingAddress2"
                          v-model="shipping.address2"
                          data-validation="optional"
                          name="shippingAddress2"
                          type="text"
                          required
                          class="w-full form-input"
                        />
                      </div>
                    </div>

                    <div class="col-span-4 sm:col-span-1">
                      <label
                        for="shippingPostcode"
                        class="block text-sm font-medium text-black"
                      >
                        Postal code
                      </label>
                      <div class="mt-1">
                        <input
                          id="shippingPostcode"
                          v-model="shipping.postcode"
                          name="shippingPostcode"
                          type="text"
                          required
                          class="w-full form-input"
                        />
                      </div>
                    </div>

                    <div class="col-span-4 sm:col-span-2 md:col-span-1">
                      <label
                        for="shippingCity"
                        class="block text-sm font-medium text-black"
                      >
                        City
                      </label>
                      <div class="mt-1">
                        <input
                          id="shippingCity"
                          v-model="shipping.city"
                          name="shippingCity"
                          type="text"
                          required
                          class="w-full form-input"
                        />
                      </div>
                    </div>

                    <div class="col-span-4 sm:col-span-2 md:col-span-1">
                      <label
                        for="shippingState"
                        class="block text-sm font-medium text-black"
                      >
                        State
                      </label>
                      <div class="mt-1">
                        <input
                          id="shippingState"
                          v-model="shipping.state"
                          name="shippingState"
                          type="text"
                          required
                          class="w-full form-input"
                        />
                      </div>
                    </div>

                    <div class="col-span-4 md:col-span-2">
                      <label
                        for="shippingCountry"
                        class="block text-sm font-medium text-black"
                      >
                        Country
                      </label>
                      <div class="mt-1">
                        <select
                          id="shippingCountry"
                          v-model="shipping.country"
                          name="shippingCountry"
                          type="text"
                          required
                          class="w-full form-select"
                        >
                          <option
                            v-for="(country, index) in countries"
                            :key="index"
                            :value="country.code"
                          >
                            {{ country.name }}
                          </option>
                        </select>
                      </div>
                    </div>
                  </div>
                </div>
                <div class="px-4 py-3 text-right bg-gray-50 sm:px-6">
                  <button
                    type="submit"
                    class="inline-flex justify-center px-4 py-2 text-sm font-medium text-white border border-transparent rounded-md shadow-sm bg-primary-300 hover:bg-primary-400 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-primary-300"
                    @click.prevent="updateCustomer"
                  >
                    Save
                  </button>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </section>
</template>

<script>
import COUNTRIES from '~/db/countries.js'

export default {
  layout: 'customer',
  data() {
    return {
      billing: {
        firstName: this.$store.state.auth.customer.billing.firstName || null,
        lastName: this.$store.state.auth.customer.billing.lastName || null,
        email: this.$store.state.auth.customer.billing.email || null,
        phone: this.$store.state.auth.customer.billing.phone || null,
        address1: this.$store.state.auth.customer.billing.address1 || null,
        address2: this.$store.state.auth.customer.billing.address2 || null,
        postcode: this.$store.state.auth.customer.billing.postcode || null,
        city: this.$store.state.auth.customer.billing.city || null,
        state: this.$store.state.auth.customer.billing.state || null,
        country: this.$store.state.auth.customer.billing.country || null,
      },
      shipping: {
        firstName: this.$store.state.auth.customer.shipping.firstName || null,
        lastName: this.$store.state.auth.customer.shipping.lastName || null,
        // email: this.$store.state.auth.customer.shipping.email || null,
        // phone: this.$store.state.auth.customer.shipping.phone || null,
        address1: this.$store.state.auth.customer.shipping.address1 || null,
        address2: this.$store.state.auth.customer.shipping.address2 || null,
        postcode: this.$store.state.auth.customer.shipping.postcode || null,
        city: this.$store.state.auth.customer.shipping.city || null,
        state: this.$store.state.auth.customer.shipping.state || null,
        country: this.$store.state.auth.customer.shipping.country || null,
      },
      sameForShipping: false,
      countries: COUNTRIES,
    }
  },
  methods: {
    updateCustomer() {
      this.$store.dispatch('auth/updateCustomer', {
        billing: this.billing,
        shipping: this.sameForShipping ? this.billing : this.shipping,
        sameForShipping: this.sameForShipping,
        redirectTo: '/profile',
      })
    },
  },
}
</script>
